define(["require", "exports", "./services"], function (require, exports, services_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DisposableCollection = exports.Disposable = void 0;
    Object.defineProperty(exports, "Disposable", { enumerable: true, get: function () { return services_1.Disposable; } });
    class DisposableCollection {
        constructor() {
            this.disposables = [];
        }
        dispose() {
            while (this.disposables.length !== 0) {
                this.disposables.pop().dispose();
            }
        }
        push(disposable) {
            const disposables = this.disposables;
            disposables.push(disposable);
            return {
                dispose() {
                    const index = disposables.indexOf(disposable);
                    if (index !== -1) {
                        disposables.splice(index, 1);
                    }
                }
            };
        }
    }
    exports.DisposableCollection = DisposableCollection;
});
//# sourceMappingURL=disposable.2c55bdfe.js.map